diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/energy/model/energy-source.cc ns-3.39/src/energy/model/energy-source.cc
--- ns-3.38/src/energy/model/energy-source.cc	2023-03-16 20:54:23.604868400 -0700
+++ ns-3.39/src/energy/model/energy-source.cc	2023-07-05 14:23:47.789427300 -0700
@@ -22,9 +22,8 @@
  * Modifications made by: Cristiano Tapparello <cristiano.tapparello@rochester.edu>
  */
 
-#include "energy-source.h"
-
-#include "ns3/log.h"
+#include <ns3/energy-source.h>
+#include <ns3/log.h>
 
 namespace ns3
 {
@@ -168,22 +167,27 @@
         totalCurrentA += (*i)->GetCurrentA();
     }
 
-    double totalHarvestedPower = 0.0;
-
-    std::vector<Ptr<EnergyHarvester>>::const_iterator harvester;
-    for (harvester = m_harvesters.begin(); harvester != m_harvesters.end(); harvester++)
+    if (!m_harvesters.empty())
     {
-        totalHarvestedPower += (*harvester)->GetPower();
-    }
+        double totalHarvestedPower = 0.0;
 
-    NS_LOG_DEBUG("EnergySource(" << GetNode()->GetId()
-                                 << "): Total harvested power = " << totalHarvestedPower);
+        std::vector<Ptr<EnergyHarvester>>::const_iterator harvester;
+        for (harvester = m_harvesters.begin(); harvester != m_harvesters.end(); harvester++)
+        {
+            totalHarvestedPower += (*harvester)->GetPower();
+        }
 
-    double currentHarvestersA = totalHarvestedPower / GetSupplyVoltage();
-    NS_LOG_DEBUG("EnergySource(" << GetNode()->GetId()
-                                 << "): Current from harvesters = " << currentHarvestersA);
+        double supplyVoltage = GetSupplyVoltage();
 
-    totalCurrentA -= currentHarvestersA;
+        if (supplyVoltage != 0)
+        {
+            double currentHarvestersA = totalHarvestedPower / supplyVoltage;
+            NS_LOG_DEBUG(" Total harvested power: " << totalHarvestedPower
+                                                    << "| Current from harvesters: "
+                                                    << currentHarvestersA);
+            totalCurrentA -= currentHarvestersA;
+        }
+    }
 
     return totalCurrentA;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/energy/model/li-ion-energy-source.h ns-3.39/src/energy/model/li-ion-energy-source.h
--- ns-3.38/src/energy/model/li-ion-energy-source.h	2023-03-16 20:54:23.604868400 -0700
+++ ns-3.39/src/energy/model/li-ion-energy-source.h	2023-07-05 14:23:47.789427300 -0700
@@ -46,7 +46,7 @@
  *
  *
  * The model requires several parameters to approximates the discharge curves:
- * - IntialCellVoltage, maximum voltage of the fully charged cell
+ * - InitialCellVoltage, maximum voltage of the fully charged cell
  * - NominalCellVoltage, nominal cell's voltage, is used to determine the end of the
  *   nominal zone.
  * - ExpCellVoltage, cell's voltage at the end of the exponential zone
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/energy/model/simple-device-energy-model.h ns-3.39/src/energy/model/simple-device-energy-model.h
--- ns-3.38/src/energy/model/simple-device-energy-model.h	2023-03-16 20:54:23.604868400 -0700
+++ ns-3.39/src/energy/model/simple-device-energy-model.h	2023-07-05 14:23:47.789427300 -0700
@@ -65,7 +65,7 @@
     virtual Ptr<Node> GetNode() const;
 
     /**
-     * \brief Sets pointer to EnergySouce installed on node.
+     * \brief Sets pointer to EnergySource installed on node.
      *
      * \param source Pointer to EnergySource installed on node.
      *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/energy/test/examples-to-run.py ns-3.39/src/energy/test/examples-to-run.py
--- ns-3.38/src/energy/test/examples-to-run.py	2023-03-16 20:54:23.604868400 -0700
+++ ns-3.39/src/energy/test/examples-to-run.py	2023-07-05 14:23:47.789427300 -0700
@@ -1,5 +1,4 @@
 #! /usr/bin/env python3
-## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
 
 # A list of C++ examples to run in order to ensure that they remain
 # buildable and runnable over time.  Each tuple in the list contains
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/fd-net-device/CMakeLists.txt ns-3.39/src/fd-net-device/CMakeLists.txt
--- ns-3.38/src/fd-net-device/CMakeLists.txt	2023-03-16 20:54:23.604868400 -0700
+++ ns-3.39/src/fd-net-device/CMakeLists.txt	2023-07-05 14:23:47.789427300 -0700
@@ -1,9 +1,3 @@
-option(
-  NS3_DPDK
-  "Enable fd-net-device DPDK features"
-  OFF
-)
-
 set(module_enabled_features) # modulegen_customizations consumes this list
 
 check_include_file(
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/fd-net-device/examples/fd-emu-onoff.cc ns-3.39/src/fd-net-device/examples/fd-emu-onoff.cc
--- ns-3.38/src/fd-net-device/examples/fd-emu-onoff.cc	2023-03-16 20:54:23.604868400 -0700
+++ ns-3.39/src/fd-net-device/examples/fd-emu-onoff.cc	2023-07-05 14:23:47.793427200 -0700
@@ -103,7 +103,6 @@
 //
 
 #include "ns3/applications-module.h"
-#include "ns3/config-store-module.h"
 #include "ns3/core-module.h"
 #include "ns3/fd-net-device-module.h"
 #include "ns3/internet-module.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/fd-net-device/examples/fd-emu-ping.cc ns-3.39/src/fd-net-device/examples/fd-emu-ping.cc
--- ns-3.38/src/fd-net-device/examples/fd-emu-ping.cc	2023-03-16 20:54:23.604868400 -0700
+++ ns-3.39/src/fd-net-device/examples/fd-emu-ping.cc	2023-07-05 14:23:47.793427200 -0700
@@ -50,7 +50,7 @@
 //  1') If you run emulation in dpdk mode, use device address (eg. 0000:00.1f.6)
 //      as device name. This address can be obtained by running `lspci`
 //  2) The host device must be set to promiscuous mode
-//     (e.g. "sudo ifconfig eth0 promisc")
+//     (e.g. "sudo ip link set eth0 promisc on")
 //  2') If you run emulation in netmap or dpdk mode, you need before to load
 //      the netmap.ko or dpdk modules. The user is in charge to configure and
 //      build netmap/dpdk separately.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/fd-net-device/examples/fd-emu-send.cc ns-3.39/src/fd-net-device/examples/fd-emu-send.cc
--- ns-3.38/src/fd-net-device/examples/fd-emu-send.cc	2023-03-16 20:54:23.604868400 -0700
+++ ns-3.39/src/fd-net-device/examples/fd-emu-send.cc	2023-07-05 14:23:47.793427200 -0700
@@ -99,7 +99,7 @@
 
         if (level == 1)
         {
-            if (device->SendFrom(packet, sender, receiver, 0) == false)
+            if (!device->SendFrom(packet, sender, receiver, 0))
             {
                 failed++;
             }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/fd-net-device/helper/dpdk-net-device-helper.h ns-3.39/src/fd-net-device/helper/dpdk-net-device-helper.h
--- ns-3.38/src/fd-net-device/helper/dpdk-net-device-helper.h	2023-03-16 20:54:23.608868600 -0700
+++ ns-3.39/src/fd-net-device/helper/dpdk-net-device-helper.h	2023-07-05 14:23:47.793427200 -0700
@@ -40,7 +40,7 @@
      */
     DpdkNetDeviceHelper();
 
-    virtual ~DpdkNetDeviceHelper()
+    ~DpdkNetDeviceHelper() override
     {
     }
 
@@ -73,7 +73,7 @@
      * \param node The node to install the device in
      * \returns A container holding the added net device.
      */
-    Ptr<NetDevice> InstallPriv(Ptr<Node> node) const;
+    Ptr<NetDevice> InstallPriv(Ptr<Node> node) const override;
 
     /**
      * Logical cores to use
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/fd-net-device/helper/encode-decode.h ns-3.39/src/fd-net-device/helper/encode-decode.h
--- ns-3.38/src/fd-net-device/helper/encode-decode.h	2023-03-16 20:54:23.608868600 -0700
+++ ns-3.39/src/fd-net-device/helper/encode-decode.h	2023-07-05 14:23:47.793427200 -0700
@@ -18,6 +18,7 @@
 #ifndef ENCODE_DECODE_H
 #define ENCODE_DECODE_H
 
+#include <cstdint>
 #include <string>
 
 namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/fd-net-device/model/dpdk-net-device.h ns-3.39/src/fd-net-device/model/dpdk-net-device.h
--- ns-3.38/src/fd-net-device/model/dpdk-net-device.h	2023-03-16 20:54:23.608868600 -0700
+++ ns-3.39/src/fd-net-device/model/dpdk-net-device.h	2023-07-05 14:23:47.797427200 -0700
@@ -61,7 +61,7 @@
     /**
      * Destructor for the DpdkNetDevice.
      */
-    ~DpdkNetDevice();
+    ~DpdkNetDevice() override;
 
     /**
      * Check the link status of all ports in up to 9s
@@ -114,20 +114,20 @@
      * Check the status of the link.
      * \return Status of the link - up/down as true/false.
      */
-    bool IsLinkUp() const;
+    bool IsLinkUp() const override;
 
     /**
      * Free the given packet buffer.
      * \param buf the pointer to the buffer to be freed
      */
-    virtual void FreeBuffer(uint8_t* buf);
+    void FreeBuffer(uint8_t* buf) override;
 
     /**
      * Allocate packet buffer.
      * \param len the length of the buffer
      * \return A pointer to the newly created buffer.
      */
-    virtual uint8_t* AllocateBuffer(size_t len);
+    uint8_t* AllocateBuffer(size_t len) override;
 
   protected:
     /**
@@ -136,7 +136,7 @@
      * \param length The data length.
      * \return The size of data written.
      */
-    ssize_t Write(uint8_t* buffer, size_t length);
+    ssize_t Write(uint8_t* buffer, size_t length) override;
 
     /**
      * The port number of the device to be used.
@@ -149,7 +149,7 @@
     std::string m_deviceName;
 
   private:
-    void DoFinishStoppingDevice();
+    void DoFinishStoppingDevice() override;
     /**
      * Condition variable for Dpdk to stop
      */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/fd-net-device/model/fd-net-device.cc ns-3.39/src/fd-net-device/model/fd-net-device.cc
--- ns-3.38/src/fd-net-device/model/fd-net-device.cc	2023-03-16 20:54:23.608868600 -0700
+++ ns-3.39/src/fd-net-device/model/fd-net-device.cc	2023-07-05 14:23:47.797427200 -0700
@@ -570,7 +570,7 @@
     NS_LOG_FUNCTION(this << packet << src << dest << protocolNumber);
     NS_LOG_LOGIC("packet: " << packet << " UID: " << packet->GetUid());
 
-    if (IsLinkUp() == false)
+    if (!IsLinkUp())
     {
         m_macTxDropTrace(packet);
         return false;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/fd-net-device/test/examples-to-run.py ns-3.39/src/fd-net-device/test/examples-to-run.py
--- ns-3.38/src/fd-net-device/test/examples-to-run.py	2023-03-16 20:54:23.608868600 -0700
+++ ns-3.39/src/fd-net-device/test/examples-to-run.py	2023-07-05 14:23:47.797427200 -0700
@@ -1,5 +1,4 @@
 #! /usr/bin/env python3
-## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
 
 # A list of C++ examples to run in order to ensure that they remain
 # buildable and runnable over time.  Each tuple in the list contains
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/flow-monitor/model/flow-monitor.cc ns-3.39/src/flow-monitor/model/flow-monitor.cc
--- ns-3.38/src/flow-monitor/model/flow-monitor.cc	2023-03-16 20:54:23.608868600 -0700
+++ ns-3.39/src/flow-monitor/model/flow-monitor.cc	2023-07-05 14:23:47.825427300 -0700
@@ -534,4 +534,31 @@
     os.close();
 }
 
+void
+FlowMonitor::ResetAllStats()
+{
+    NS_LOG_FUNCTION(this);
+
+    for (auto& iter : m_flowStats)
+    {
+        auto& flowStat = iter.second;
+        flowStat.delaySum = Seconds(0);
+        flowStat.jitterSum = Seconds(0);
+        flowStat.lastDelay = Seconds(0);
+        flowStat.txBytes = 0;
+        flowStat.rxBytes = 0;
+        flowStat.txPackets = 0;
+        flowStat.rxPackets = 0;
+        flowStat.lostPackets = 0;
+        flowStat.timesForwarded = 0;
+        flowStat.bytesDropped.clear();
+        flowStat.packetsDropped.clear();
+
+        flowStat.delayHistogram.Clear();
+        flowStat.jitterHistogram.Clear();
+        flowStat.packetSizeHistogram.Clear();
+        flowStat.flowInterruptionsHistogram.Clear();
+    }
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/flow-monitor/model/flow-monitor.h ns-3.39/src/flow-monitor/model/flow-monitor.h
--- ns-3.38/src/flow-monitor/model/flow-monitor.h	2023-03-16 20:54:23.608868600 -0700
+++ ns-3.39/src/flow-monitor/model/flow-monitor.h	2023-07-05 14:23:47.825427300 -0700
@@ -273,6 +273,9 @@
     /// \param enableProbes if true, include also the per-probe/flow pair statistics in the output
     void SerializeToXmlFile(std::string fileName, bool enableHistograms, bool enableProbes);
 
+    /// Reset all the statistics
+    void ResetAllStats();
+
   protected:
     void NotifyConstructionCompleted() override;
     void DoDispose() override;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/flow-monitor/test/examples-to-run.py ns-3.39/src/flow-monitor/test/examples-to-run.py
--- ns-3.38/src/flow-monitor/test/examples-to-run.py	2023-03-16 20:54:23.608868600 -0700
+++ ns-3.39/src/flow-monitor/test/examples-to-run.py	2023-07-05 14:23:47.825427300 -0700
@@ -1,5 +1,4 @@
 #! /usr/bin/env python3
-## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
 
 # A list of C++ examples to run in order to ensure that they remain
 # buildable and runnable over time.  Each tuple in the list contains
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/CMakeLists.txt ns-3.39/src/internet/CMakeLists.txt
--- ns-3.38/src/internet/CMakeLists.txt	2023-03-16 20:54:23.612868500 -0700
+++ ns-3.39/src/internet/CMakeLists.txt	2023-07-05 14:23:47.829427500 -0700
@@ -262,6 +262,7 @@
 set(test_sources
     test/global-route-manager-impl-test-suite.cc
     test/icmp-test.cc
+    test/internet-stack-helper-test-suite.cc
     test/ipv4-address-generator-test-suite.cc
     test/ipv4-address-helper-test-suite.cc
     test/ipv4-deduplication-test.cc
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/examples/neighbor-cache-example.cc ns-3.39/src/internet/examples/neighbor-cache-example.cc
--- ns-3.38/src/internet/examples/neighbor-cache-example.cc	2023-03-16 20:54:23.612868500 -0700
+++ ns-3.39/src/internet/examples/neighbor-cache-example.cc	2023-07-05 14:23:47.837427400 -0700
@@ -283,7 +283,6 @@
 #include "ns3/csma-module.h"
 #include "ns3/internet-module.h"
 #include "ns3/network-module.h"
-#include "ns3/point-to-point-module.h"
 
 using namespace ns3;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/helper/internet-stack-helper.cc ns-3.39/src/internet/helper/internet-stack-helper.cc
--- ns-3.38/src/internet/helper/internet-stack-helper.cc	2023-03-16 20:54:23.612868500 -0700
+++ ns-3.39/src/internet/helper/internet-stack-helper.cc	2023-07-05 14:23:47.837427400 -0700
@@ -20,22 +20,22 @@
 
 #include "internet-stack-helper.h"
 
+#include "ipv4-global-routing-helper.h"
+#include "ipv4-list-routing-helper.h"
+#include "ipv4-static-routing-helper.h"
+#include "ipv6-static-routing-helper.h"
+
 #include "ns3/arp-l3-protocol.h"
 #include "ns3/assert.h"
 #include "ns3/callback.h"
 #include "ns3/config.h"
-#include "ns3/core-config.h"
 #include "ns3/global-router-interface.h"
 #include "ns3/icmpv6-l4-protocol.h"
-#include "ns3/ipv4-global-routing-helper.h"
 #include "ns3/ipv4-global-routing.h"
-#include "ns3/ipv4-list-routing-helper.h"
-#include "ns3/ipv4-static-routing-helper.h"
 #include "ns3/ipv4.h"
 #include "ns3/ipv6-extension-demux.h"
 #include "ns3/ipv6-extension-header.h"
 #include "ns3/ipv6-extension.h"
-#include "ns3/ipv6-static-routing-helper.h"
 #include "ns3/ipv6.h"
 #include "ns3/log.h"
 #include "ns3/names.h"
@@ -129,7 +129,6 @@
 void
 InternetStackHelper::Initialize()
 {
-    SetTcp("ns3::TcpL4Protocol");
     Ipv4StaticRoutingHelper staticRouting;
     Ipv4GlobalRoutingHelper globalRouting;
     Ipv4ListRoutingHelper listRouting;
@@ -152,7 +151,6 @@
     m_routingv6 = o.m_routingv6->Copy();
     m_ipv4Enabled = o.m_ipv4Enabled;
     m_ipv6Enabled = o.m_ipv6Enabled;
-    m_tcpFactory = o.m_tcpFactory;
     m_ipv4ArpJitterEnabled = o.m_ipv4ArpJitterEnabled;
     m_ipv6NsRsJitterEnabled = o.m_ipv6NsRsJitterEnabled;
 }
@@ -267,12 +265,6 @@
 }
 
 void
-InternetStackHelper::SetTcp(const std::string tid)
-{
-    m_tcpFactory.SetTypeId(tid);
-}
-
-void
 InternetStackHelper::Install(NodeContainer c) const
 {
     for (NodeContainer::Iterator i = c.Begin(); i != c.End(); ++i)
@@ -290,6 +282,12 @@
 void
 InternetStackHelper::CreateAndAggregateObjectFromTypeId(Ptr<Node> node, const std::string typeId)
 {
+    TypeId tid = TypeId::LookupByName(typeId);
+    if (node->GetObject<Object>(tid))
+    {
+        return;
+    }
+
     ObjectFactory factory;
     factory.SetTypeId(typeId);
     Ptr<Object> protocol = factory.Create<Object>();
@@ -301,42 +299,33 @@
 {
     if (m_ipv4Enabled)
     {
-        if (node->GetObject<Ipv4>())
-        {
-            NS_FATAL_ERROR("InternetStackHelper::Install (): Aggregating "
-                           "an InternetStack to a node with an existing Ipv4 object");
-            return;
-        }
-
+        /* IPv4 stack */
         CreateAndAggregateObjectFromTypeId(node, "ns3::ArpL3Protocol");
         CreateAndAggregateObjectFromTypeId(node, "ns3::Ipv4L3Protocol");
         CreateAndAggregateObjectFromTypeId(node, "ns3::Icmpv4L4Protocol");
-        if (m_ipv4ArpJitterEnabled == false)
+        if (!m_ipv4ArpJitterEnabled)
         {
             Ptr<ArpL3Protocol> arp = node->GetObject<ArpL3Protocol>();
             NS_ASSERT(arp);
             arp->SetAttribute("RequestJitter",
                               StringValue("ns3::ConstantRandomVariable[Constant=0.0]"));
         }
+
         // Set routing
         Ptr<Ipv4> ipv4 = node->GetObject<Ipv4>();
-        Ptr<Ipv4RoutingProtocol> ipv4Routing = m_routing->Create(node);
-        ipv4->SetRoutingProtocol(ipv4Routing);
+        if (!ipv4->GetRoutingProtocol())
+        {
+            Ptr<Ipv4RoutingProtocol> ipv4Routing = m_routing->Create(node);
+            ipv4->SetRoutingProtocol(ipv4Routing);
+        }
     }
 
     if (m_ipv6Enabled)
     {
         /* IPv6 stack */
-        if (node->GetObject<Ipv6>())
-        {
-            NS_FATAL_ERROR("InternetStackHelper::Install (): Aggregating "
-                           "an InternetStack to a node with an existing Ipv6 object");
-            return;
-        }
-
         CreateAndAggregateObjectFromTypeId(node, "ns3::Ipv6L3Protocol");
         CreateAndAggregateObjectFromTypeId(node, "ns3::Icmpv6L4Protocol");
-        if (m_ipv6NsRsJitterEnabled == false)
+        if (!m_ipv6NsRsJitterEnabled)
         {
             Ptr<Icmpv6L4Protocol> icmpv6l4 = node->GetObject<Icmpv6L4Protocol>();
             NS_ASSERT(icmpv6l4);
@@ -345,9 +334,11 @@
         }
         // Set routing
         Ptr<Ipv6> ipv6 = node->GetObject<Ipv6>();
-        Ptr<Ipv6RoutingProtocol> ipv6Routing = m_routingv6->Create(node);
-        ipv6->SetRoutingProtocol(ipv6Routing);
-
+        if (!ipv6->GetRoutingProtocol())
+        {
+            Ptr<Ipv6RoutingProtocol> ipv6Routing = m_routingv6->Create(node);
+            ipv6->SetRoutingProtocol(ipv6Routing);
+        }
         /* register IPv6 extensions and options */
         ipv6->RegisterExtensions();
         ipv6->RegisterOptions();
@@ -357,9 +348,12 @@
     {
         CreateAndAggregateObjectFromTypeId(node, "ns3::TrafficControlLayer");
         CreateAndAggregateObjectFromTypeId(node, "ns3::UdpL4Protocol");
-        node->AggregateObject(m_tcpFactory.Create<Object>());
-        Ptr<PacketSocketFactory> factory = CreateObject<PacketSocketFactory>();
-        node->AggregateObject(factory);
+        CreateAndAggregateObjectFromTypeId(node, "ns3::TcpL4Protocol");
+        if (!node->GetObject<PacketSocketFactory>())
+        {
+            Ptr<PacketSocketFactory> factory = CreateObject<PacketSocketFactory>();
+            node->AggregateObject(factory);
+        }
     }
 
     if (m_ipv4Enabled)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/helper/internet-stack-helper.h ns-3.39/src/internet/helper/internet-stack-helper.h
--- ns-3.38/src/internet/helper/internet-stack-helper.h	2023-03-16 20:54:23.612868500 -0700
+++ ns-3.39/src/internet/helper/internet-stack-helper.h	2023-07-05 14:23:47.837427400 -0700
@@ -144,8 +144,8 @@
 
     /**
      * Aggregate implementations of the ns3::Ipv4, ns3::Ipv6, ns3::Udp, and ns3::Tcp classes
-     * onto the provided node.  This method will assert if called on a node that
-     * already has an Ipv4 object aggregated to it.
+     * onto the provided node.  This method will do nothing if the stacks are already installed,
+     * and will not overwrite existing stacks parameters.
      *
      * \param nodeName The name of the node on which to install the stack.
      */
@@ -153,8 +153,8 @@
 
     /**
      * Aggregate implementations of the ns3::Ipv4, ns3::Ipv6, ns3::Udp, and ns3::Tcp classes
-     * onto the provided node.  This method will assert if called on a node that
-     * already has an Ipv4 object aggregated to it.
+     * onto the provided node.  This method will do nothing if the stacks are already installed,
+     * and will not overwrite existing stacks parameters.
      *
      * \param node The node on which to install the stack.
      */
@@ -162,9 +162,8 @@
 
     /**
      * For each node in the input container, aggregate implementations of the
-     * ns3::Ipv4, ns3::Ipv6, ns3::Udp, and, ns3::Tcp classes.  The program will assert
-     * if this method is called on a container with a node that already has
-     * an Ipv4 object aggregated to it.
+     * ns3::Ipv4, ns3::Ipv6, ns3::Udp, and, ns3::Tcp classes.  This method will do nothing if the
+     * stacks are already installed, and will not overwrite existing stacks parameters.
      *
      * \param c NodeContainer that holds the set of nodes on which to install the
      * new stacks.
@@ -177,19 +176,6 @@
     void InstallAll() const;
 
     /**
-     * \brief set the Tcp stack which will not need any other parameter.
-     *
-     * This function sets up the tcp stack to the given TypeId. It should not be
-     * used for NSC stack setup because the nsc stack needs the Library attribute
-     * to be setup, please use instead the version that requires an attribute
-     * and a value. If you choose to use this function anyways to set nsc stack
-     * the default value for the linux library will be used: "liblinux2.6.26.so".
-     *
-     * \param tid the type id, typically it is set to  "ns3::TcpL4Protocol"
-     */
-    void SetTcp(std::string tid);
-
-    /**
      * \brief Enable/disable IPv4 stack install.
      * \param enable enable state
      */
@@ -291,11 +277,6 @@
     void Initialize();
 
     /**
-     * \brief TCP objects factory
-     */
-    ObjectFactory m_tcpFactory;
-
-    /**
      * \brief IPv4 routing helper.
      */
     const Ipv4RoutingHelper* m_routing;
@@ -306,7 +287,8 @@
     const Ipv6RoutingHelper* m_routingv6;
 
     /**
-     * \brief create an object from its TypeId and aggregates it to the node
+     * \brief create an object from its TypeId and aggregates it to the node. Does nothing if
+     * an object of the same type is already aggregated to the node.
      * \param node the node
      * \param typeId the object TypeId
      */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/helper/ipv6-interface-container.cc ns-3.39/src/internet/helper/ipv6-interface-container.cc
--- ns-3.38/src/internet/helper/ipv6-interface-container.cc	2023-03-16 20:54:23.612868500 -0700
+++ ns-3.39/src/internet/helper/ipv6-interface-container.cc	2023-07-05 14:23:47.837427400 -0700
@@ -21,7 +21,8 @@
 
 #include "ipv6-interface-container.h"
 
-#include "ns3/ipv6-static-routing-helper.h"
+#include "ipv6-static-routing-helper.h"
+
 #include "ns3/names.h"
 #include "ns3/node-list.h"
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/helper/neighbor-cache-helper.cc ns-3.39/src/internet/helper/neighbor-cache-helper.cc
--- ns-3.38/src/internet/helper/neighbor-cache-helper.cc	2023-03-16 20:54:23.612868500 -0700
+++ ns-3.39/src/internet/helper/neighbor-cache-helper.cc	2023-07-05 14:23:47.841427300 -0700
@@ -17,7 +17,7 @@
  * Author: Zhiheng Dong <dzh2077@gmail.com>
  */
 
-#include "ns3/neighbor-cache-helper.h"
+#include "neighbor-cache-helper.h"
 
 #include "ns3/assert.h"
 #include "ns3/channel-list.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/helper/ripng-helper.cc ns-3.39/src/internet/helper/ripng-helper.cc
--- ns-3.38/src/internet/helper/ripng-helper.cc	2023-03-16 20:54:23.612868500 -0700
+++ ns-3.39/src/internet/helper/ripng-helper.cc	2023-07-05 14:23:47.841427300 -0700
@@ -24,6 +24,8 @@
 #include "ns3/node.h"
 #include "ns3/ripng.h"
 
+#include <map>
+
 namespace ns3
 {
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/helper/ripng-helper.h ns-3.39/src/internet/helper/ripng-helper.h
--- ns-3.38/src/internet/helper/ripng-helper.h	2023-03-16 20:54:23.612868500 -0700
+++ ns-3.39/src/internet/helper/ripng-helper.h	2023-07-05 14:23:47.841427300 -0700
@@ -25,6 +25,8 @@
 #include "ns3/node.h"
 #include "ns3/object-factory.h"
 
+#include <map>
+
 namespace ns3
 {
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/arp-cache.cc ns-3.39/src/internet/model/arp-cache.cc
--- ns-3.38/src/internet/model/arp-cache.cc	2023-03-16 20:54:23.616868500 -0700
+++ ns-3.39/src/internet/model/arp-cache.cc	2023-07-05 14:23:47.841427300 -0700
@@ -18,7 +18,6 @@
  */
 #include "arp-cache.h"
 
-#include "arp-header.h"
 #include "ipv4-header.h"
 #include "ipv4-interface.h"
 
@@ -551,11 +550,7 @@
     Time timeout = GetTimeout();
     Time delta = Simulator::Now() - m_lastSeen;
     NS_LOG_DEBUG("delta=" << delta.GetSeconds() << "s");
-    if (delta > timeout)
-    {
-        return true;
-    }
-    return false;
+    return delta > timeout;
 }
 
 ArpCache::Ipv4PayloadHeaderPair
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/arp-l3-protocol.cc ns-3.39/src/internet/model/arp-l3-protocol.cc
--- ns-3.38/src/internet/model/arp-l3-protocol.cc	2023-03-16 20:54:23.616868500 -0700
+++ ns-3.39/src/internet/model/arp-l3-protocol.cc	2023-07-05 14:23:47.841427300 -0700
@@ -276,7 +276,7 @@
             break;
         }
     }
-    if (found == false)
+    if (!found)
     {
         NS_LOG_LOGIC("node=" << m_node->GetId() << ", got request from "
                              << arp.GetSourceIpv4Address() << " for unknown address "
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/global-route-manager-impl.cc ns-3.39/src/internet/model/global-route-manager-impl.cc
--- ns-3.38/src/internet/model/global-route-manager-impl.cc	2023-03-16 20:54:23.616868500 -0700
+++ ns-3.39/src/internet/model/global-route-manager-impl.cc	2023-07-05 14:23:47.841427300 -0700
@@ -26,14 +26,13 @@
 #include "candidate-queue.h"
 #include "global-router-interface.h"
 #include "ipv4-global-routing.h"
+#include "ipv4.h"
 
 #include "ns3/assert.h"
 #include "ns3/fatal-error.h"
-#include "ns3/ipv4-list-routing.h"
-#include "ns3/ipv4-routing-protocol.h"
-#include "ns3/ipv4.h"
 #include "ns3/log.h"
 #include "ns3/node-list.h"
+#include "ns3/simulator.h"
 
 #include <algorithm>
 #include <iostream>
@@ -1216,7 +1215,7 @@
             // skipped a previous link and moved forward to the next (which is then the
             // one we want).
             //
-            if (skip == false)
+            if (!skip)
             {
                 NS_LOG_LOGIC("Returning the found link");
                 return l;
